(function () {

    unLoadChapterList = true;
    //加载正文、更新章节标示

    var FrontPageAPI = {

        loadChapter: function (json) {
            if (json.status == 200) {
                preChapter = json.preChapter;
                nextChapter = json.nextChapter;
                content = json.novelContent;
                height = json.height || 0;
                novelLink = json.novelLink || "";
                if (json.extra_data) {
                    extra_data = json.extra_data;
                }

                content = content.replace(/&nbsp;/g, "");
                content = '<p>' + content.replace(/\n/g, '</p><p>') + '</p>';
                content = content.replace(/\s+/g, "");

                $('#title').html(json.title);
                $('#content').html(content);
                if (novelLink) {
                    $('#link').html(novelLink);
                } else {
                    $('#link_wrap').hide();
                }

                // adResult = JSON.parse(json.adResult);
                if (json.adResult && JSON.parse(json.adResult).adInfoList.length > 0) {
                    haveAd = true;
                    haveShowAd = false;
                    adResult = JSON.parse(json.adResult);
                    adConf = adResult.adConf;
                    adInfoList = adResult.adInfoList;
                } else {
                    haveAd = false;
                }

                // window.scroll(0, height);
                //加载目录
                if (unLoadChapterList) {
                    setTimeout("NovelTransInvoker.loadChapterList('FrontPageAPI.loadChapterList')", 500);
                }

                FrontPageAPI.intialSetting();

            } else {
                toast(json.status, 2000);
            }
        },

        //加载下一章
        loadNextChapter: function () {
            NovelTransInvoker.loadNextChapter(nextChapter, 'FrontPageAPI.loadChapter');
        },

        //加载前一章
        loadPreChapter: function () {
            NovelTransInvoker.loadPreviousChapter(preChapter, 'FrontPageAPI.loadChapter');
        },

        //加载目录
        loadChapterList: function (json) {
            if (json.status == 200) {
                var tempList = json.chapterList;
                chapterList = [];
                $('#totalNumber').html("本书共" + json.totalChapterNumber + "章");
                totalChapterNumber = json.totalChapterNumber;
                for (var i = 0; i < tempList.length; i++) {
                    chapterList.push('<li ckey="' + tempList[i].ckey + '" index = "' + tempList[i].index + '"><a href="javascript:void(0)">' + tempList[i].name + '</a></li>');
                }

                $('#catalog-title').show();
                $('#loading').hide();
                $('#chapterList').append(chapterList.join(''));
                unLoadChapterList = false;
                myScroll.refresh();
            } else {
                toast(json.status, 2000);
            }
        },

        loadHorizontalAd:function(json){
            if (json && json.pageAd && json.pageAd.title) {

                $('.ad-col1-new .ad-box>h3').html(json.pageAd.title);
                $('.ad-col1-new .ad-box .ad-cover>img').attr("src",json.pageAd.image);
                NovelTransInvoker.showAd('horizontal.page');

                AdPosition = "chapterMid";
                $('.wrapper').hide();
                $('.ad-col1-new').show();
                $('.hand-btn').show();

                $('body').on('touchstart', swipe);
            }else{
                var oBox = document.querySelector('.read_page');
                if (direction == 'left'){
                    // 下一页
                    n++;
                    x = -n * columnWidth;
                    oBox.style.WebkitTransform = 'translateX(' + x + 'px)';

                } else{
                    // 上一页
                    n--;
                    if (n < 0) {
                        n = 0
                    }
                    x = -n * columnWidth;
                    oBox.style.WebkitTransition = '.2s all ease';
                    oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
                }
            }
        },

        loadAd: function (json) {
            if (json && json.pageAd && json.pageAd.title) {
                var vpArray = [];
                vpArray.push('<div class="read-ad02-wrap vertical mid-content" id="vpad-container">');
                vpArray.push('<div class="read-ad02" id="vpad-box">');
                vpArray.push('<div class="book-cover">');
                vpArray.push('<img src="' + json.pageAd.image + '" alt="" id="vpad-image">');
                vpArray.push('<i class="icon-ad icon-ad02"></i>');
                vpArray.push('</div>');
                vpArray.push('<div class="book-detail">' + json.pageAd.title + '</div>');
                vpArray.push('<div class="book-btn-wrap">');
                vpArray.push('<div class="note">智能优选</div>');
                vpArray.push('<div class="book-btn">立即查看</div>');
                vpArray.push('</div>');
                vpArray.push('</div>');
                vpArray.push('</div>');

                var cps = $('#content>p');
                if (cps && cps.length >= 2) {
                    var idx = cps.length / 2 - 1;
                    //tracy(2020-03-18):测试发现可能出现加载两次的问题，所以增加一个检测，如果已经有了就不添加了
                    if (!document.getElementById('vpad-container')) {
                        cps.eq(idx).after(vpArray.join(''));
                        NovelTransInvoker.showAd('vertical.page');
                    }
                }
            } else {

            }
        },

        // 设置、上下章节等控制条的展现与隐藏切换。
        // 若控制条存在，调用该方法隐藏控制条；若控制条隐藏，调用该方法展现控制条。
        controlBarToggle: function () {
            if ($('#subnav').css('display') != 'none') {
                controlBarHide();
            } else {
                controlBarShow();
            }
        },

        // App获取控制条展现状态
        getControlBarStatus: function () {
            return $('#subnav').css('display') != 'none' ? 'show' : 'hide';
        },
        loadSetting: function (conf) {
            var json;
            if (conf) {
                json = JSON.parse(conf);
                haveIntialSetting = true;
            } else {
                return;
            }

            userConf.bgColor = json.bgColor || 0;
            userConf.fontSize = json.fontSize || 20;
            userConf.lineHeight = json.lineHeight || 1.6;
            userConf.flipType = json.flipType || "vertical";
            userConf.nightMode = json.nightMode || "off";

        },

        loadAdConfig: function (adConf) {
            pageStart = adConf.pageStart || 5;
            frequency = adConf.frequency || 5;
        },

        //背景颜色、字体初始化
        intialSetting: function () {
            $('.vertical-ad-col1,.vertical-ad-col2,.vertical-ad-col3').hide();

            if (haveAd) {

                var style = adConf.style;
                console.log("adConf="+JSON.stringify(adConf));

                setAdInfo(style, 'vertical');
                setAdInfo(style, 'horizontal');

                if (userConf.flipType == 'vertical') {
                    $('.vertical-ad-col' + style).show();
                    var adelement = $('.vertical-ad-col' + style + ' img');
                    for (var i = 0; i < adelement.length; i++) {
                        AdShowReport(adelement.eq(i));
                    }
                }
            }


            if (userConf.flipType == 'horizontal') {

                if (haveIntialHorizontalFlip) {
                    FlipUtils.setPage(flipActivity);
                    return;
                } else {
                    FlipUtils.setFlipType(userConf.flipType);
                    $('#horizontal').addClass('cur');
                    $('#vertical').removeClass('cur');
                    haveIntialHorizontalFlip = true;
                }
                //快速左右翻页的时候 有滚动条 会导致翻页错乱，左右翻页的时候禁掉滚动条。
                $('html').css('overflow-x', 'hidden');

            } else {

                //禁掉 滚动条，会导致window.scroll 方法不能用，所以此处再放开
                NovelTransInvoker.loadAd("vertical.page", "FrontPageAPI.loadAd");

            }

            if (userConf.fontSize) {
                $('#main').css('font-size', parseInt(userConf.fontSize));
            }

            if (userConf.lineHeight) {
                $('#main p').css('line-height', userConf.lineHeight);
            }
            if (userConf.nightMode == 'on') {
                $('body').attr('class', 'bg-night');
                $('#nightMode').removeClass('night');
                $('#nightMode').html($('#nightMode').html().replace('夜间', '白天'));
                APPLogUtil.EnumTypeLog("mj_306_2_0", "1");

            } else {
                $('body').attr('class', themes[userConf.bgColor]);
                $('#theme>div>a').removeClass('themebox-cur');
                // $('#theme>div').removeClass('selected');
                $('#theme>div').eq(userConf.bgColor).children().addClass('themebox-cur');
                // $('#theme>div').eq(userConf.bgColor).addClass('selected');
            }

            window.scroll(0, 0);

            // 设置广告样式
            function setAdInfo(style, flipType) {
                for (var i = 0; i < adInfoList.length; i++) {

                    var curl = adInfoList[i].curl == null ? '' : adInfoList[i].curl;
                    var iurl = adInfoList[i].iurl == null ? '' : adInfoList[i].iurl;
                    var apk_name = adInfoList[i].apk_name == null ? '' : adInfoList[i].apk_name;
                    var durl = adInfoList[i].durl == null ? '' : adInfoList[i].durl;
                    var curl = adInfoList[i].curl == null ? '' : adInfoList[i].curl;
                    var adid = adInfoList[i].adid == null ? '' : adInfoList[i].adid;

                    $('.' + flipType + '-ad-col' + style + ' img').eq(i).attr("source", adConf.type)
                        .attr("link", adInfoList[i].link)
                        .attr("src", adInfoList[i].imglist[0])
                        .attr("pos", i + 1)
                        .attr('style', style)
                        .attr("curl", curl)
                        .attr("iurl", iurl)
                        .attr("apk_name", apk_name)
                        .attr("durl", durl)
                        .attr("adid", adid);
                }

                if (style == 3) {
                    var title = adInfoList[0].title == null ? '' : adInfoList[0].title;
                    $('.ad-title').text(title);
                }
            }


        },

        //app获取滚动条滚动的高度
        getScrollTop: function () {
            return parseInt(document.body.scrollTop);
        },

        //设置滚动条滚动高度
        setScrollTop: function (height) {
            window.scroll(0, height);
        },
        //app获取extra字段
        getExtraData: function () {
            NovelTransInvoker.onReceiveExtraData(extra_data);
        },
        uploadLastConf: function () {
            if (userConf.flipType == 'vertical') {
                APPLogUtil.EnumTypeLog("mj_306_2_1", "0");
            } else {
                APPLogUtil.EnumTypeLog("mj_306_2_1", "1");
            }
            APPLogUtil.EnumTypeLog("mj_306_2_2", userConf.fontSize);
            APPLogUtil.EnumTypeLog("mj_306_2_3", userConf.lineHeight);
            APPLogUtil.EnumTypeLog("mj_306_2_4", userConf.bgColor);
            APPLogUtil.EnumTypeLog("mj_306_2_5", userConf.nightMode);

        }

    };

    window.FrontPageAPI = FrontPageAPI;

    //冒泡提示
    window.toast = function (tip, intVal) {
        intVal = intVal || 2500;
        if ($('#abs-toast').length == 0) {
            $('body').prepend('<div id="abs-toast" style="display: none;width:206px;text-align: center;border-radius: 2px;background-color: rgba(0, 0, 0, 0.48);position: fixed;top: 220px;left: 50%;line-height: 28px;margin: 0 0 0 -103px;color: #fff;padding: 5px;z-index: 999;"></div>');
        }
        var $toast = $('#abs-toast');
        if ($toast.css('display') != 'none')
            return;
        $toast.html(tip);
        $toast.show();
        setTimeout(function () {
            $toast.hide();
        }, intVal);
    };

})(window)

window.FlipUtils = {
    setFlipType: function (type) {
        $("#main").unbind("click");
        var $main = $('#main');
        var oBox = document.querySelector('.read_page');
        var oCon = oBox.querySelector('.read_page_con');
        if (!$main.hasClass("read_page")) {
            $main.addClass("read_page");
        }
        x = 0;
        n = 0;
        _offset = 30;
        columnWidth = 0;
        pages = 0;
        title = "";
        document.body.style.overflow = 'hidden';
        document.body.style.position = 'fixed';
        FlipUtils.setPage();
        FlipUtils.fnTouch();
        haveIntialHorizontalFlip = true;
    },

    setPage: function (trigger) {
        setTimeout(function () {
            var oBox = document.querySelector('.read_page');
            var oCon = oBox.querySelector('.read_page_con');
            //title content
            var title = $('#title').html(),
                con = $('#content').html();
            $("#title").html(title);
            $('#content').html(con);
            $('.loading-btns').hide();
            columnWidth = oCon.clientWidth + 16;
            oBox.style.WebkitColumnWidth = columnWidth + 'px';
            clientHeight = document.documentElement.clientHeight - _offset;
            oBox.style.height = clientHeight + 'px';

            oBox.style.WebkitTransition = 'none';
            pages = Math.ceil(oCon.offsetHeight / (document.documentElement.clientHeight - _offset));
            if (pages == 0) {
                pages = 1;
            }
            if (trigger == 'horizontalPre') {
                n = pages - 1;
            }
            if (trigger == 'horizontalNext' || trigger == 'btnFlip') {
                n = 0;
            }

            /* n=Math.ceil(oCon.offsetHeight/(document.documentElement.clientHeight-_offset))*n/pages;// 当前总页数*转屏前的第n页/转屏前的总页数
            n=Math.floor(n);// 当前页，向下取整*/

            x = -n * columnWidth;
            oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
            flipActivity = "";

        }, 200);
    },

    fnTouch: function () {
        var $main = document.getElementById('main');
        var oBox = document.querySelector('.read_page');
        var oCon = oBox.querySelector('.read_page_con');
        $main.addEventListener('touchstart', function (ev) {

            oBox.style.WebkitTransition = 'none';
            var disX = ev.targetTouches[0].pageX - x;
            var startX = ev.targetTouches[0].pageX;
            var startY = ev.targetTouches[0].pageY;

            function fnEnd(ev) {
                var endX, endY;
                endX = ev.changedTouches[0].pageX;
                endY = ev.changedTouches[0].pageY;
                // $main.removeEventListener('touchmove',fnMove,false);
                $main.removeEventListener('touchend', fnEnd, false);
                columnWidth = oCon.clientWidth + 16;
                // 判断是向左滑 还是向右滑
                if (Math.abs(startX - endX) > 10 && startX > endX) {
                    controlBarHide();

                    console.log("n=" + n + "_" + pageStart + "_" + pages);
                    if (n + 1 >= pageStart  &&  (n + 1 - pageStart ) % frequency == 0 && (n + 1) != pages ) {
                        direction = 'left';
                        NovelTransInvoker.loadAd("horizontal.page", "FrontPageAPI.loadHorizontalAd");
                        return ;
                    }

                    if ((n + 1) == pages) {
                        if (haveAd && !haveShowAd) {
                            showAd('chapterEnd');
                        } else {
                            flipActivity = "horizontalNext";
                            NovelTransInvoker.loadNextChapter(nextChapter, 'FrontPageAPI.loadChapter');
                            APPLogUtil.CountTypeLog("js_306_1_7");
                            APPLogUtil.CountTypeLog("js_306_1_8");
                        }

                        return;
                    }

                    n++;
                    x = -n * columnWidth;
                    oBox.style.WebkitTransition = '.2s all ease';
                    oBox.style.WebkitTransform = 'translateX(' + x + 'px)';

                } else if (Math.abs(startX - endX) > 10 && startX < endX) {
                    controlBarHide();

                    console.log("n=" + n + "_" + pageStart + "_" + pages);
                    console.log("directionClosed="+directionClosed);
                    if ( n >= pageStart  &&  !directionClosed &&  (n - pageStart ) % frequency == 0 && (n + 1) != pages ) {
                        direction = 'right';
                        NovelTransInvoker.loadAd("horizontal.page", "FrontPageAPI.loadHorizontalAd");
                        return ;
                    }

                    if (n == 0) {
                        if (haveAd && !haveShowAd) {
                            showAd('chapterStart');
                        } else {
                            flipActivity = "horizontalPre";
                            NovelTransInvoker.loadPreviousChapter(preChapter, 'FrontPageAPI.loadChapter');
                            APPLogUtil.CountTypeLog("js_306_1_6");
                            APPLogUtil.CountTypeLog("js_306_1_8");
                        }

                        return;
                    }

                    n--;
                    if (n < 0) {
                        n = 0
                    }

                    x = -n * columnWidth;
                    oBox.style.WebkitTransition = '.2s all ease';
                    oBox.style.WebkitTransform = 'translateX(' + x + 'px)';

                    directionClosed = false ;

                } else {
                    if (startX > columnWidth * 2 / 3 || (startY > clientHeight * 3 / 4 && startX > columnWidth * 1 / 3)) {

                        controlBarHide();

                        console.log("n=" + n + "_" + pageStart + "_" + pages);
                        if (n + 1 >= pageStart  &&  (n + 1 - pageStart ) % frequency == 0 && (n + 1) != pages ) {
                            direction = 'left';
                            NovelTransInvoker.loadAd("horizontal.page", "FrontPageAPI.loadHorizontalAd");
                            return ;
                        }

                        if ((n + 1) == pages) {
                            if (haveAd && !haveShowAd) {
                                showAd('chapterEnd');
                            } else {
                                flipActivity = "horizontalNext";
                                NovelTransInvoker.loadNextChapter(nextChapter, 'FrontPageAPI.loadChapter');
                                APPLogUtil.CountTypeLog("js_306_1_7");
                                APPLogUtil.CountTypeLog("js_306_1_8");
                            }
                            return;
                        }

                        n++;
                        x = -n * columnWidth;
                        oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
                    } else if (startX < columnWidth / 3 || (startY < clientHeight * 1 / 4 && startX < columnWidth * 2 / 3)) {
                        controlBarHide();

                        console.log("n=" + n + "_" + pageStart + "_" + pages);
                        console.log("directionClosed="+directionClosed);
                        if ( n >= pageStart && !directionClosed &&  (n - pageStart ) % frequency == 0 && (n + 1) != pages ) {
                            direction = 'right';
                            NovelTransInvoker.loadAd("horizontal.page", "FrontPageAPI.loadHorizontalAd");
                            return ;
                        }

                        if (n == 0) {
                            if (haveAd && !haveShowAd) {
                                showAd('chapterStart');
                            } else {
                                flipActivity = "horizontalPre";
                                NovelTransInvoker.loadPreviousChapter(preChapter, 'FrontPageAPI.loadChapter');
                                APPLogUtil.CountTypeLog("js_306_1_6");
                                APPLogUtil.CountTypeLog("js_306_1_8");
                            }

                            return;
                        }

                        n--;
                        if (n < 0) {
                            n = 0
                        }
                        x = -n * columnWidth;
                        oBox.style.WebkitTransform = 'translateX(' + x + 'px)';

                        directionClosed = false ;

                    } else {
                        controlBartoggle();
                    }
                }
            }

            // $main.addEventListener('touchmove',fnMove,false);
            $main.addEventListener('touchend', fnEnd, false);
            ev.preventDefault();
        }, false);
    }

}


window.APPLogUtil = {

    CountTypeLog: function (key) {
        NovelTransInvoker.onCountEvent(key);
    },
    EnumTypeLog: function (key, value) {
        NovelTransInvoker.onEnumEvent(key, value);
    },
    CustomTypeLog: function (key, value) {
        NovelTransInvoker.onCustomEvent(key, value);
    }

}

function throttle(fn, interval) {
    var last;
    var timer;
    var interval = interval || 200;
    return function () {
        var th = this;
        var args = arguments;
        var now = +new Date();
        if (last && now - last < interval) {
            clearTimeout(timer);
            timer = setTimeout(function () {
                last = now;
                fn.apply(th, args);
            }, interval);
        } else {
            last = now;
            fn.apply(th, args);
        }
    }
}

function AdClickReport(ele) {

    var json = {
        "adId": ele.attr('adId'),
        "style": ele.attr('style'),
        "pos": ele.attr('pos'),
        "curl": ele.attr('curl')
    }

    NovelTransInvoker.onAdClick(JSON.stringify(json));
}

function AdShowReport(ele) {
    var json = {
        "adId": ele.attr('adId'),
        "style": ele.attr('style'),
        "pos": ele.attr('pos'),
        "iurl": ele.attr('iurl')
    };
    NovelTransInvoker.onAdShow(JSON.stringify(json));
}

function showAd(position) {
    haveShowAd = true;
    AdPosition = position;
    var adelement = $('.horizontal-ad-col' + adConf.style + ' img');
    $('.wrapper').hide();
    $('.ad-col' + adConf.style).show();
    $('.hand-btn').show();
    for (var i = 0; i < adelement.length; i++) {
        AdShowReport(adelement.eq(i));
    }
    $('body').on('touchstart', swipe);
}

function swipe(ev) {
    var endX;
    var startX = ev.targetTouches[0].pageX;
    var startY = ev.targetTouches[0].pageY;
    var oBox = document.querySelector('.read_page');
    $('body').on('touchend', tounchEnd);

    function tounchEnd(ev) {
        endX = ev.changedTouches[0].pageX;
        $('body').unbind('touchend');

        // 判断是向左滑 还是向右滑
        if (Math.abs(startX - endX) > 10 && startX > endX) {
            if (AdPosition == 'chapterStart') {
                hideAd();
            } else if (AdPosition == 'chapterEnd') {
                flipActivity = "horizontalNext";
                NovelTransInvoker.loadNextChapter(nextChapter, 'FrontPageAPI.loadChapter');
                hideAd();
            }else if (AdPosition == 'chapterMid'){

                hideHorizontalAd();
                console.log('n='+n);

                n++;
                x = -n * columnWidth;
                oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
            }

        } else if (Math.abs(startX - endX) > 10 && startX < endX) {
            if (AdPosition == 'chapterStart') {
                flipActivity = "horizontalPre";
                NovelTransInvoker.loadPreviousChapter(preChapter, 'FrontPageAPI.loadChapter');
                hideAd();
            } else if (AdPosition == 'chapterEnd') {
                hideAd();
            }else if (AdPosition == 'chapterMid'){

                hideHorizontalAd();

                directionClosed = true;

                console.log('n='+n);

                // n--;
                // if (n < 0) {
                //     n = 0
                // }
                // x = -n * columnWidth;
                // oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
            }
        }
    }

    function hideHorizontalAd() {
        $('.wrapper').show();
        $('.ad-col1-new').hide();
        $('.hand-btn').hide();
        $('body').unbind('touchstart');
    }

    function hideAd() {
        var style = adConf.style;
        console.log("hideAd");
        $('.wrapper').show();
        $('.ad-col' + style).hide();
        $('.hand-btn').hide();
        $('body').unbind('touchstart');
    }


}



