$(function(){
	var html5Uploader = null;
	var files = [];
	var curContainerIndex = 0;
	var curContainerSize = 10;
	var currentFileName;
	var html5='1';
	
    var uploadQueue = [];
    var currentQueueIndex = 0;
    var isUploading = false;
    var getProgressReties = 0;
    
    var items = {};
	
    
    function getQueryStringRegExp(name)
    {
        var reg = new RegExp("(^|\\?|&)"+ name +"=([^&]*)(\\s|&|$)", "i");  
        if (reg.test(location.href)) return unescape(RegExp.$2.replace(/\+/g, " ")); return "";
    };
    
	function uploadFiles(files){
		var uploader = getHtml5Uploader();
		if(files.length==1){
			var msg = checkFileName(files[0].name || files[0].fileName);// check file type
			if(msg){
				alert(msg);
				return;
			}
			uploader.add(files[0]);
			return;
		}
		
		var totalFiles = files.length;
		var realFiles = 0;
		for(var i=0;i<totalFiles;i++){
			if(!checkFileName(files[i].name || files[i].fileName)){
				uploader.add(files[i]);
				realFiles++;
			}
		}
		if(realFiles!=totalFiles){
			console.log(STRINGS.UNSUPPORTED_FILE_TYPE);
		}
	}

	function checkFileName(fileName){
		 if (!fileName || !fileName.toLowerCase().match('(epub|txt|pdf|umd|ttf|ttc)$')) {
	            return STRINGS.UNSUPPORTED_FILE_TYPE;
	        }

	        var arr = fileName.split("\\");
	        fileName = arr[arr.length - 1];

	        var hasFile = false;
	        var existFile = $("#drag-area .cboxm[filename='" + escape(fileName) + "']");
	        if (existFile.length > 0) {
	              return STRINGS.FILE_EXISTS;
	        }
	        return null;
	}
	
	function genFileItem(item){
		var fileName = item.getFilename();
		var fileSize = item.getSize();
		var htmlStr = [];
		htmlStr.push('<div class="cboxm_t1">'+formatName(fileName)+'</div>');
		htmlStr.push('<div class="cboxm_t2">'+formatFileSize(fileSize)+'</div>');
		htmlStr.push('<div class="cboxm_t3">0%</div>');
		htmlStr.push('<div class="cboxm_t4"><a class="del" href="javascript:void(0)"></a></div>');
		htmlStr.push('<div class="cbox_plan" style="width:0%"></div>');
		return htmlStr.join('');
	}
	
	function genSimpleFileItem(fileName){
		var htmlStr = [];
		htmlStr.push('<div class="cboxm_t1">'+formatName(fileName)+'</div>');
		htmlStr.push('<div class="cboxm_t2"> - </div>');
		htmlStr.push('<div class="cboxm_t3">0%</div>');
		htmlStr.push('<div class="cbox_plan" style="width:0%"></div>');
		return htmlStr.join('');
	}
	
	function formatName(fileName){
		if(fileName.length>22)
			return fileName.substr(0,19)+'...';
		else
			return fileName;
	}

	 function formatFileSize(value) {
	        var multiplyFactor = 0;
	        var tokens = ["bytes", "KB", "MB", "GB", "TB"];
	        while (value > 1024) {
	            value /= 1024;
	            multiplyFactor++;
	        }
	        return value.toFixed(1) + " " + tokens[multiplyFactor];
	    }
	
	
	function getHtml5Uploader(){
		if(!html5Uploader){
			html5Uploader = new bitcandies.FileUploader({
				url: '/upload',
				maxconnections: 1,
				filedname: 'newfile',
				enqueued:  function(item){
					if(curContainerIndex>curContainerSize-2){
						increaseContainer();
					}
					var fileName = item.getFilename();
                    items[escape(fileName)] = item;
					var htmlStr = genFileItem(item);
					var eleCurContainer = $('#drag-area').children('.cboxm').eq(curContainerIndex);
					curContainerIndex++;
					eleCurContainer.addClass('cbox_bg');
					eleCurContainer.append(htmlStr);
					eleCurContainer.attr('filename',escape(item.getFilename()));
					eleCurContainer.children('.cboxm_t4').children('a').click(cancelUpload);
				},
				progress: function(item, loaded, total){
					var fileName = item.getFilename();
					var ele=$('#drag-area .cboxm[filename="' + escape(fileName) + '"]');
					ele.children('.cboxm_t4').html('');
					var progress=Math.round(loaded/total*100)+'%';
					var elePercent = ele.children('.cboxm_t3');
					var imgPercent = ele.children('.cbox_plan');
					elePercent.text(progress);
					imgPercent.css('width',progress);
				},
				success: function(item){
					var fileName = item.getFilename();
					var ele=$('#drag-area .cboxm[filename="' + escape(fileName) + '"]');
					ele.removeClass('cbox_bg');
					ele.children('.cboxm_t3').html(STRINGS.UPLOAD_SUCC);
					ele.children('.cbox_plan').css('display','none');
					ele.children('.cboxm_t4').css('display','none');
				},
				error: function(item){
					var fileName = item.getFilename();
					var ele=$('#drag-area .cboxm[filename="' + escape(fileName) + '"]');
					$('#upload-area').attr('value','');
//					ele.html('');
//					ele.attr('filename','');
//					ele.removeClass('cbox_bg');
//					curContainerIndex--;
					ele.remove();
					curContainerIndex--;
					curContainerSize--;
					alert(STRINGS.UPLOAD_FAIL);
				},
				aborted: function(item){
					var fileName = item.getFilename();
					var ele=$('#drag-area .cboxm[filename="' + escape(fileName) + '"]');
//					ele.html('');
//                 ele.attr('filename','');
//                 curContainerIndex--;
					ele.remove();
					curContainerIndex--;
					curContainerSize--;
				}
			});
		}
		return html5Uploader;
	}

	 function cancelUpload() {
	        var uploader = getHtml5Uploader();
	        var cancelContainer = $(this).parent().parent('.cboxm');
	        var fileName = cancelContainer.attr('filename');
	        if (fileName) {
	            item = items[fileName];
	            if (item) {
	                uploader.abort(item);
	                $('#upload-area').attr('value','');
	            }
	        }
	    }
	
	 function increaseContainer(){
		 var htmlStr = '<div class="cboxm cbox_hui"></div><div class="cboxm"></div><div class="cboxm cbox_hui"></div><div class="cboxm"></div><div class="cboxm cbox_hui"></div><div class="cboxm"></div><div class="cboxm cbox_hui"></div><div class="cboxm"></div><div class="cboxm cbox_hui"></div><div class="cboxm"></div>';
		 $('#drag-area').append(htmlStr);
		 curContainerSize+=10;
	 }
	 
	function startAjaxUpload(){
		if (isUploading || currentQueueIndex >= uploadQueue.length) {
            return;
        }
		
		isUploading = true;
        var eleFile = $(uploadQueue[currentQueueIndex]);
        var eleFileId = eleFile.attr('id');
        var fileName = eleFile.val();
        var arr = fileName.split("\\");
        fileName = arr[arr.length - 1];
        if(curContainerIndex>curContainerSize-2){
			increaseContainer();
		}
        currentQueueIndex++;
        $.ajaxFileUpload({
            url: '/upload',
            secureuri: false,
            fileElementId: eleFileId,
            dataType: 'text',
            success: function(data, status) {
                var ele=$('#drag-area .cboxm[filename="' + escape(fileName) + '"]');
                ele.removeClass('cbox_bg');
                ele.children('.cboxm_t3').text(STRINGS.UPLOAD_SUCC);
            	var imgPercent = ele.children('.cbox_plan');
				imgPercent.css('display','none');
				 isUploading = false;
                startAjaxUpload();
            },
            error: function(data, status, e) {
                alert(STRINGS.UPLOAD_FAIL);
                curContainerIndex--;
                var ele=$('#drag-area .cboxm[filename="' + escape(fileName) + '"]');
                ele.remove();
				curContainerIndex--;
				curContainerSize--;
				 isUploading = false;
                startAjaxUpload();
            }
        });

        currentFileName = fileName;
        setTimeout(getUploadProgress, 300);
	}
	
	function getUploadProgress() {
        var time = new Date().getTime();
        var url = '/progress?' + time;
        $.getJSON(url, function(data) {
            if (!data) {
                getProgressReties++
                if (getProgressReties < 5) {
                    setTimeout(getUploadProgress, 500);
                    return;
                } else {
                    alert(STRINGS.USE_ONE_BROWSER);
                }
            }
            
            var total = data.total;
            var processed = data.processed;
			var ele=$('#drag-area .cboxm[filename="' + escape(currentFileName) + '"]');
			var progress = '0%';
			var elePercent = ele.children('.cboxm_t3');
			var imgPercent = ele.children('.cbox_plan');
			if(total>0){
				progress=Math.round(processed/total*100)+'%';
            	var size = formatFileSize(total);
            	ele.children('.cboxm_t2').html(size);
            	elePercent.text(progress);
    			imgPercent.css('width',progress);
            }

            if (isUploading) {
                setTimeout(getUploadProgress, 300);
            } else {
               // ele.removeClass('cbox_bg');
				//ele.children('.cbox_plan').css('display','none');
				//elePercent.text('100%');
				//elePercent.text(STRINGS.UPLOAD_SUCC);
            }
        });
    }

	function dragUpload(fileArea){
		$(fileArea).unbind();
		$(fileArea).change(function(){
			if(curContainerIndex>curContainerSize-2){
				increaseContainer();
			}
			
			if(this.files && html5 == '1'){// html5 upload
				uploadFiles(this.files);
				return;
			}
			
			var fileName=$(this).val();
			//check file type
			var msg = checkFileName(fileName);
            if (msg) {
                alert(msg);
                return;
            }
			
            var arr = fileName.split("\\");
            fileName = arr[arr.length - 1];
            var htmlStr = genSimpleFileItem(fileName);
            
            var eleCurContainer = $('#drag-area').children('.cboxm').eq(curContainerIndex);
			curContainerIndex++;
			eleCurContainer.addClass('cbox_bg');
			eleCurContainer.append(htmlStr);
			eleCurContainer.attr('filename',escape(fileName));
            uploadQueue.push(fileArea);
            $(fileArea).css({
                top: '-9999px',
                left: '-9999px',
                display:'none'
            });
            $('.upload_b').prepend('<input type="file" name="newfile" value="" id="newfile_' + uploadQueue.length + '"/>');
            dragUpload('#newfile_' + uploadQueue.length);
            startAjaxUpload();
		});
		
			 $(fileArea).mouseover(function() {
				 $('#upload_button').removeClass('upload_b').addClass('pressed');
	     })
	         .mouseout(function() {
	        	 $('#upload_button').removeClass('pressed').addClass('upload_b');
	     })
	         .mousedown(function() {
	        	 $('#upload_button').removeClass('upload_b').addClass('pressed');
	     })
	         .mouseup(function() {
	        	 $('#upload_button').removeClass('pressed').addClass('upload_b');
	     });
	}
	$(document).ready(function(){
		var _html5= getQueryStringRegExp('html5');
		if(_html5 != '')
			html5 = _html5;
		dragUpload('#upload-area');
	});
});